Bug 1349371 - gcc-go fails to link golang-googlecode-net
Summary: gcc-go fails to link golang-googlecode-net
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: gcc
Version: 24
Hardware: All
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jakub Jelinek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1326890
TreeView+ depends on / blocked
 
Reported: 2016-06-23 10:44 UTC by Dan Horák
Modified: 2017-08-08 14:59 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-08 14:59:37 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
GNU Compiler Collection 71635 None None None 2016-06-23 15:58:59 UTC

Description Dan Horák 2016-06-23 10:44:25 UTC
build of golang-googlecode-net package fails with gcc-go (checked on s390x in koji and manually on x86_64) due a linking error

...
+ go test -compiler gccgo -gccgoflags '-O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -march=z9-109 -mtune=z10 ' golang.org/x/net/ipv4
# testmain
/tmp/go-build546930784/golang.org/x/net/libipv4.a(_go_.o): In function `golang_org_x_net_ipv4.set.pN28_golang_org_x_net_ipv4.rawOpt':
/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/control.go:18: multiple definition of `golang_org_x_net_ipv4.set.pN28_golang_org_x_net_ipv4.rawOpt'
/tmp/go-build546930784/golang.org/x/net/ipv4/_test/golang.org/x/net/libipv4.a(_go_.o):/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/control.go:18: first defined here
/tmp/go-build546930784/golang.org/x/net/libipv4.a(_go_.o): In function `golang_org_x_net_ipv4.clear.pN28_golang_org_x_net_ipv4.rawOpt':
/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/control.go:19: multiple definition of `golang_org_x_net_ipv4.clear.pN28_golang_org_x_net_ipv4.rawOpt'
/tmp/go-build546930784/golang.org/x/net/ipv4/_test/golang.org/x/net/libipv4.a(_go_.o):/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/control.go:19: first defined here
/tmp/go-build546930784/golang.org/x/net/libipv4.a(_go_.o): In function `golang_org_x_net_ipv4.isset.pN28_golang_org_x_net_ipv4.rawOpt':
/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/control.go:20: multiple definition of `golang_org_x_net_ipv4.isset.pN28_golang_org_x_net_ipv4.rawOpt'
/tmp/go-build546930784/golang.org/x/net/ipv4/_test/golang.org/x/net/libipv4.a(_go_.o):/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/control.go:20: first defined here
/tmp/go-build546930784/golang.org/x/net/libipv4.a(_go_.o): In function `golang_org_x_net_ipv4.ok.pN32_golang_org_x_net_ipv4.genericOpt':
/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/endpoint.go:24: multiple definition of `golang_org_x_net_ipv4.ok.pN32_golang_org_x_net_ipv4.genericOpt'
/tmp/go-build546930784/golang.org/x/net/ipv4/_test/golang.org/x/net/libipv4.a(_go_.o):/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/endpoint.go:24: first defined here
/tmp/go-build546930784/golang.org/x/net/libipv4.a(_go_.o): In function `golang_org_x_net_ipv4.ok.pN30_golang_org_x_net_ipv4.dgramOpt':
/builddir/build/BUILDROOT/golang-googlecode-net-0-0.32.gitbc3663d.fc25.s390x/usr/share/gocode/src/golang.org/x/net/ipv4/endpoint.go:48: multiple definition of `golang_org_x_net_ipv4.ok.pN30_golang_org_x_net_ipv4.dgramOpt'
...

for full log please see http://s390.koji.fedoraproject.org/koji/taskinfo?taskID=2266794

upstream sources for the package is https://github.com/golang/net

Version-Release number of selected component (if applicable):
gcc-go-6.1.1-2.fc24

Comment 1 Dan Horák 2016-06-23 11:19:46 UTC
a standalone reproducer with my limited Go-foo (might require some additional golang-* packages installed)

mkdir -p src/golang.org/x/
cd src/golang.org/x/
git clone https://github.com/golang/net.git
cd ../..
GOPATH=`pwd`/.. go test golang.org/x/net/ipv4

Comment 2 Dan Horák 2016-06-23 11:27:24 UTC
There is no such problem with gcc-go-5.3.1-6.fc22.x86_64.

Comment 3 Dan Horák 2016-07-11 12:54:12 UTC
For the record golang-googlecode-goprotobuf seems to suffer from the same problem - http://s390.koji.fedoraproject.org/koji/taskinfo?taskID=2282191

...
Executing(%check): /bin/sh -e /var/tmp/rpm-tmp.yDwZ0d
+ umask 022
+ cd /builddir/build/BUILD
+ cd protobuf-8616e8ee5e20a1704615e6c8d7afcdac06087a67
+ export GOPATH=/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x//usr/share/gocode:/usr/share/gocode
+ GOPATH=/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x//usr/share/gocode:/usr/share/gocode
+ gotest github.com/golang/protobuf/jsonpb
+ go test github.com/golang/protobuf/jsonpb
ok  	github.com/golang/protobuf/jsonpb	0.267s
+ gotest github.com/golang/protobuf/proto
+ go test github.com/golang/protobuf/proto
# testmain
/tmp/go-build580954407/github.com/golang/protobuf/libproto.a(_go_.o):(.rodata.github_com_golang_protobuf_proto.extensionAdapter$hash$descriptor+0x0): multiple definition of `github_com_golang_protobuf_proto.extensionAdapter$hash$descriptor'
/tmp/go-build580954407/github.com/golang/protobuf/proto/_test/github.com/golang/protobuf/libproto.a(_go_.o):(.rodata.github_com_golang_protobuf_proto.extensionAdapter$hash$descriptor+0x0): first defined here
/tmp/go-build580954407/github.com/golang/protobuf/libproto.a(_go_.o): In function `github_com_golang_protobuf_proto.Clone':
/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x/usr/share/gocode/src/github.com/golang/protobuf/proto/clone.go:44: multiple definition of `github_com_golang_protobuf_proto.extensionAdapter$equal$descriptor'
/tmp/go-build580954407/github.com/golang/protobuf/proto/_test/github.com/golang/protobuf/libproto.a(_go_.o):/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x/usr/share/gocode/src/github.com/golang/protobuf/proto/clone.go:44: first defined here
/tmp/go-build580954407/github.com/golang/protobuf/libproto.a(_go_.o): In function `github_com_golang_protobuf_proto.Clone':
/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x/usr/share/gocode/src/github.com/golang/protobuf/proto/clone.go:44: multiple definition of `__go_tdn_github_com_golang_protobuf_proto.ExtensionDesc$gc'
/tmp/go-build580954407/github.com/golang/protobuf/proto/_test/github.com/golang/protobuf/libproto.a(_go_.o):/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x/usr/share/gocode/src/github.com/golang/protobuf/proto/clone.go:44: first defined here
/tmp/go-build580954407/github.com/golang/protobuf/libproto.a(_go_.o): In function `github_com_golang_protobuf_proto.Clone':
/builddir/build/BUILDROOT/golang-googlecode-goprotobuf-0-0.22.git8616e8e.fc25.s390x/usr/share/gocode/src/github.com/golang/protobuf/proto/clone.go:44: multiple definition of `__go_tdn_github_com_golang_protobuf_proto.Extension$gc'
...

Comment 4 Fedora End Of Life 2017-07-25 21:14:27 UTC
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 5 Fedora End Of Life 2017-08-08 14:59:37 UTC
Fedora 24 changed to end-of-life (EOL) status on 2017-08-08. Fedora 24 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.